## gate.gui
Class SerialControllerEditor

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JPanel
                              |
                              +--gate.creole.AbstractVisualResource
                                    |
                                    +--gate.gui.SerialControllerEditor

All Implemented Interfaces:
  Accessible, CreoleListener, EventListener, FeatureBearer, ImageObserver, MenuContainer, NameBearer, Resource, Serializable, VisualResource

public class SerialControllerEditor
extends AbstractVisualResource
implements CreoleListener

See Also:
  Serialized Form

Inner Class Summary
`(package private) class` `SerialControllerEditor.AddPRAction` Adds a PR to the controller
`protected class` `SerialControllerEditor.CorporaComboModel` A model for a combobox containing the loaded corpora in the system
`protected class` `SerialControllerEditor.InternalProgressListener` A simple progress listener used to forward the events upstream.
`protected class` `SerialControllerEditor.InternalStatusListener` A simple status listener used to forward the events upstream.
`(package private) class` `SerialControllerEditor.LoadedPRsTableModel` Table model for all the loaded processing resources that are not part of the controller.
`(package private) class` `SerialControllerEditor.MemberPRsTableModel` Table model for all the processing resources in the controller.
`(package private) class` `SerialControllerEditor.RemovePRAction` Removes a PR from the controller
`(package private) class` `SerialControllerEditor.RunAction` Runs the Application

Inner classes inherited from class javax.swing.JPanel
`JPanel.AccessibleJPanel`

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent, JComponent.ActionStandin, JComponent.IntVector, JComponent.KeyboardState`

Inner classes inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Inner classes inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.AWTTreeLock`

Field Summary
`(package private) JButton` `addButon` Adds one or more PR(s) to the controller
`(package private) JMenu` `addMenu` The "Add PR" menu; part of the popup menu
`(package private) boolean` `analyserMode`
`(package private) SerialController` `controller` The controller this editor edits
`(package private) JComboBox` `corpusCombo` A combobox that allows selection of a corpus from the list of loaded corpora.
`(package private) SerialControllerEditor.CorporaComboModel` `corpusComboModel`
`(package private) Handle` `handle` The `Handle` that created this view
`(package private) XJTable` `loadedPRsTable` Contains all the PRs loaded in the sytem that are not already part of the serial controller
`(package private) SerialControllerEditor.LoadedPRsTableModel` `loadedPRsTableModel` model for the `loadedPRsTable` JTable.
`(package private) XJTable` `memberPRsTable` Displays the PRs in the controller
`(package private) SerialControllerEditor.MemberPRsTableModel` `memberPRsTableModel` model for `memberPRsTable`
`(package private) JButton` `moveDownButton` Moves the module down in the controller list
`(package private) JButton` `moveUpButton` Moves the module up in the controller list
`(package private) TitledBorder` `parametersBorder` A border for the `parametersPanel`
`(package private) ResourceParametersEditor` `parametersEditor` A component for editing the parameters of the currently selected PR
`(package private) JPanel` `parametersPanel` A JPanel containing the `parametersEditor`
`private Vector` `progressListeners`
`(package private) JButton` `removeButton` Removes one or more PR(s) from the controller
`(package private) JMenu` `removeMenu` The "Remove PR" menu; part of the popup menu
`(package private) SerialControllerEditor.RunAction` `runAction` Action that runs the application
`private Vector` `statusListeners`

Fields inherited from class gate.creole.AbstractVisualResource
`features`

Fields inherited from class javax.swing.JPanel
`defaultLayout, uiClassID`

Fields inherited from class javax.swing.JComponent

`_bounds, accessibleContext, actionMap, ACTIONMAP_CREATED, alignmentX, alignmentY, ANCESTOR_INPUTMAP_CREATED, ANCESTOR_USING_BUFFER, ancestorInputMap, ancestorNotifier, autoscroller, border, changeSupport, clientProperties, CREATED_DOUBLE_BUFFER, flags, FOCUS_INPUTMAP_CREATED, focusInputMap, HAS_FOCUS, htmlKey, htmlView, inputVerifier, IS_DOUBLE_BUFFERED, IS_OPAQUE, IS_PAINTING_TILE, IS_PRINTING, IS_PRINTING_ALL, KEY_EVENTS_ENABLED, KEYBOARD_BINDINGS_KEY, listenerList, maximumSize, minimumSize, NEXT_FOCUS, paintImmediatelyClip, paintingChild, preferredSize, readObjectCallbacks, REQUEST_FOCUS_DISABLED, tmpRect, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, verifyInputWhenFocusTarget, vetoableChangeSupport, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW, WHEN_IN_FOCUSED_WINDOW_BINDINGS, WIF_INPUTMAP_CREATED, windowInputMap`

Fields inherited from class java.awt.Container
`component, containerListener, containerSerializedDataVersion, dbg, dispatcher, layoutMgr, listeningBoundsChildren, listeningChildren, maxSize, ncomponents, printing, printingThreads, serialVersionUID`

Fields inherited from class java.awt.Component

`actionListenerK, adjustmentListenerK, appContext, background, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, componentListener, componentListenerK, componentOrientation, componentSerializedDataVersion, containerListenerK, cursor, dropTarget, enabled, eventMask, focusListener, focusListenerK, font, foreground, graphicsConfig, hasFocus, height, hierarchyBoundsListener, hierarchyBoundsListenerK, hierarchyListener, hierarchyListenerK, incRate, inputMethodListener, inputMethodListenerK, isInc, isPacked, itemListenerK, keyListener, keyListenerK, LEFT_ALIGNMENT, locale, LOCK, metrics, minSize, mouseListener, mouseListenerK, mouseMotionListener, mouseMotionListenerK, name, nameExplicitlySet, newEventsOnly, ownedWindowK, parent, peer, peerFont, popups, prefSize, privateKey, RIGHT_ALIGNMENT, textListenerK, TOP_ALIGNMENT, valid, visible, width, windowClosingException, windowListenerK, x, y`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`SerialControllerEditor()`

Method Summary
`void` `addProgressListener(ProgressListener l)`
`void` `addStatusListener(StatusListener l)`
`void` `datastoreClosed(CreoleEvent e)` Called when a `DataStore` has been closed
`void` `datastoreCreated(CreoleEvent e)` Called when a `DataStore` has been created
`void` `datastoreOpened(CreoleEvent e)` Called when a `DataStore` has been opened
`protected void` `fireProcessFinished()`
`protected void` `fireProgressChanged(int e)`
`protected void` `fireStatusChanged(String e)`
`Resource` `init()` Initialise this resource, and return it.
`protected void` `initGuiComponents()`
`protected void` `initListeners()`
`protected void` `initLocalData()`
`void` `removeProgressListener(ProgressListener l)`
`void` `removeStatusListener(StatusListener l)`
`void` `resourceLoaded(CreoleEvent e)` Called when a new `Resource` has been loaded into the system
`void` `resourceUnloaded(CreoleEvent e)` Called when a `Resource` has been removed from the system
`void` `setHandle(Handle handle)` Used by the main GUI to tell this VR what handle created it.
`void` `setTarget(Object target)` Called by the GUI when this viewer/editor has to initialise itself for a specific object.
`protected void` `showParamsEditor(ProcessingResource pr)` Stops the current edits for parameters; sets the paarmeters for the resource currently being edited and diplays the editor for the new resource

Methods inherited from class gate.creole.AbstractVisualResource
`cleanup, getFeatures, getParameterValue, setFeatures, setParameterValue, setParameterValues`

Methods inherited from class javax.swing.JPanel
`<clinit>, getAccessibleContext, getUIClassID, paramString, updateUI, writeObject`

Methods inherited from class javax.swing.JComponent

`_paintImmediately, addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, adjustPaintFlags, alwaysOnTop, checkIfChildObscuredBySibling, clearFocusOwners, componentInputMapChanged, computeVisibleRect, computeVisibleRect, compWriteObjectNotify, contains, createToolTip, disable, enable, enableSerialization, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getActionMap, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperties, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getCreatedDoubleBuffer, getDebugGraphicsOptions, getFlag, getGraphics, getHeight, getInputMap, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVerifyInputWhenFocusTarget, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, hide, isDoubleBuffered, isFocusCycleRoot, isFocusTraversable, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paintWithBuffer, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processFocusEvent, processKeyBinding, processKeyBindings, processKeyBindingsForAllComponents, processKeyEvent, processMouseMotionEvent, putClientProperty, readObject, rectangleIsObscured, rectangleIsObscuredBySibling, registerKeyboardAction, registerKeyboardAction, registerWithKeyboardManager, registerWithKeyboardManager, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setCreatedDoubleBuffer, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFlag, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPaintingChild, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVerifyInputWhenFocusTarget, setVisible, shouldDebugGraphics, superProcessMouseMotionEvent, unregisterKeyboardAction, unregisterWithKeyboardManager, unregisterWithKeyboardManager, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, adjustListeningChildren, applyOrientation, checkGD, countComponents, createChildHierarchyEvents, createHierarchyEvents, deliverEvent, dispatchEventImpl, dispatchEventToSelf, doLayout, eventEnabled, findComponentAt, findComponentAt, findComponentAt, getAccessibleAt, getAccessibleChild, getAccessibleChildrenCount, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents_NoClientCode, getComponents, getLayout, getMouseEventTarget, getWindow, initIDs, insets, invalidate, invalidateTree, isAncestorOf, layout, lightweightPaint, lightweightPrint, list, list, locate, minimumSize, nextFocus, numListening, paintComponents, paintHeavyweightComponents, postProcessKeyEvent, postsOldMouseEvents, preferredSize, preProcessKeyEvent, printComponents, printHeavyweightComponents, processContainerEvent, processEvent, proxyEnableEvents, proxyRequestFocus, remove, remove, removeAll, removeContainerListener, setFocusOwner, setLayout, transferFocus, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, areInputMethodsEnabled, bounds, checkImage, checkImage, checkWindowClosingException, coalesceEvents, constructComponentName, contains, createImage, createImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getAccessibleIndexInParent, getAccessibleStateSet, getBackground, getBounds, getColorModel, getComponentOrientation, getCursor, getDropTarget, getFont_NoClientCode, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getInputContext, getInputMethodRequests, getLocale, getLocation, getLocationOnScreen_NoTreeLock, getLocationOnScreen, getName, getNativeContainer, getParent_NoClientCode, getParent, getPeer, getSize, getToolkit, getToolkitImpl, getTreeLock, getWindowForObject, gotFocus, handleEvent, imageUpdate, inside, isDisplayable, isEnabled, isEnabledImpl, isLightweight, isRecursivelyVisible, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resetGC, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, wait, wait, wait`

Methods inherited from interface gate.util.NameBearer
`getName, setName`

Field Detail

### controller

    SerialController controller

  The controller this editor edits

### handle

    Handle handle

  The `Handle` that created this view

### loadedPRsTable

    XJTable loadedPRsTable

  Contains all the PRs loaded in the sytem that are not already part of the serial controller

### loadedPRsTableModel

    SerialControllerEditor.LoadedPRsTableModel loadedPRsTableModel

  model for the `loadedPRsTable` JTable.

### memberPRsTable

    XJTable memberPRsTable

  Displays the PRs in the controller

### memberPRsTableModel

    SerialControllerEditor.MemberPRsTableModel memberPRsTableModel

  model for `memberPRsTable`

### addButon

    JButton addButon

  Adds one or more PR(s) to the controller

### removeButton

    JButton removeButton

  Removes one or more PR(s) from the controller

### moveUpButton

    JButton moveUpButton

  Moves the module up in the controller list

### moveDownButton

    JButton moveDownButton

  Moves the module down in the controller list

### parametersEditor

    ResourceParametersEditor parametersEditor

  A component for editing the parameters of the currently selected PR

### parametersPanel

    JPanel parametersPanel

  A JPanel containing the `parametersEditor`

### parametersBorder

    TitledBorder parametersBorder

  A border for the `parametersPanel`

### corpusCombo

    JComboBox corpusCombo

  A combobox that allows selection of a corpus from the list of loaded corpora.

### corpusComboModel

    SerialControllerEditor.CorporaComboModel corpusComboModel

### addMenu

    JMenu addMenu

  The "Add PR" menu; part of the popup menu

### removeMenu

    JMenu removeMenu

  The "Remove PR" menu; part of the popup menu

### runAction

    SerialControllerEditor.RunAction runAction

  Action that runs the application

### analyserMode

    boolean analyserMode

### statusListeners

    private transient Vector statusListeners

### progressListeners

    private transient Vector progressListeners

Constructor Detail

### SerialControllerEditor

    public SerialControllerEditor()

Method Detail

### setTarget

    public void setTarget(Object target)

  Description copied from class: `AbstractVisualResource`
  Called by the GUI when this viewer/editor has to initialise itself for a specific object.
  Overrides:
    `setTarget` in class `AbstractVisualResource`
  Following copied from class: `gate.creole.AbstractVisualResource`
  Parameters:
    `target` - the object (be it a `Resource`, `DataStore` or whatever) this viewer has to display

### setHandle

    public void setHandle(Handle handle)

  Description copied from class: `AbstractVisualResource`
  Used by the main GUI to tell this VR what handle created it. The VRs can use this information e.g. to add items to the popup for the resource.
  Overrides:
    `setHandle` in class `AbstractVisualResource`

### init

    public Resource init()
                  throws ResourceInstantiationException

  Description copied from class: `AbstractVisualResource`
  Initialise this resource, and return it.
  Overrides:
    `init` in class `AbstractVisualResource`

### initLocalData

    protected void initLocalData()

### initGuiComponents

    protected void initGuiComponents()

### initListeners

    protected void initListeners()

### showParamsEditor

    protected void showParamsEditor(ProcessingResource pr)

  Stops the current edits for parameters; sets the paarmeters for the resource currently being edited and diplays the editor for the new resource
  Parameters:
    `pr` - the new resource

### resourceLoaded

    public void resourceLoaded(CreoleEvent e)

  Description copied from interface: `CreoleListener`
  Called when a new `Resource` has been loaded into the system
  Specified by:
    `resourceLoaded` in interface `CreoleListener`

### resourceUnloaded

    public void resourceUnloaded(CreoleEvent e)

  Description copied from interface: `CreoleListener`
  Called when a `Resource` has been removed from the system
  Specified by:
    `resourceUnloaded` in interface `CreoleListener`

### datastoreOpened

    public void datastoreOpened(CreoleEvent e)

  Description copied from interface: `CreoleListener`
  Called when a `DataStore` has been opened
  Specified by:
    `datastoreOpened` in interface `CreoleListener`

### datastoreCreated

    public void datastoreCreated(CreoleEvent e)

  Description copied from interface: `CreoleListener`
  Called when a `DataStore` has been created
  Specified by:
    `datastoreCreated` in interface `CreoleListener`

### datastoreClosed

    public void datastoreClosed(CreoleEvent e)

  Description copied from interface: `CreoleListener`
  Called when a `DataStore` has been closed
  Specified by:
    `datastoreClosed` in interface `CreoleListener`

### removeStatusListener

    public void removeStatusListener(StatusListener l)

### addStatusListener

    public void addStatusListener(StatusListener l)

### fireStatusChanged

    protected void fireStatusChanged(String e)

### removeProgressListener

    public void removeProgressListener(ProgressListener l)

### addProgressListener

    public void addProgressListener(ProgressListener l)

### fireProgressChanged

    protected void fireProgressChanged(int e)

### fireProcessFinished

    protected void fireProcessFinished()